Index: /trunk/prototype/modules/mail/js/label.js
===================================================================
--- /trunk/prototype/modules/mail/js/label.js	(revision 5533)
+++ /trunk/prototype/modules/mail/js/label.js	(revision 5533)
@@ -0,0 +1,533 @@
+function colors_suggestions(){
+	return [
+				{name:'Padrão', border:'#3366cc', font:'#ffffff', background:'#3366cc'},
+				{name:'Coala', border:'#123456', font:'#ffffff', background:'#385c80'},
+				{name:'Tomate', border:'#d5130b', font:'#111111', background:'#e36d76'},
+				{name:'Limão', border:'#32ed21', font:'#1f3f1c', background:'#b2f1ac'},
+				{name:'Alto contraste', border:'#000000', font:'#ffffff', background:'#222222'}
+			]		
+}
+function rgb2hex(rgb){
+ rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
+ return "#" +
+  ("0" + parseInt(rgb[1],10).toString(16)).slice(-2) +
+  ("0" + parseInt(rgb[2],10).toString(16)).slice(-2) +
+  ("0" + parseInt(rgb[3],10).toString(16)).slice(-2);
+}
+
+function init_label(data){
+
+	winElement = data.window;
+
+	var configureLabel = function(event, ui){
+		var idmarkernow = $(this).find('[name="labelItemId"]').val();
+		winElement.find('.edit-label').val(idmarkernow);
+		winElement.find('.input-nome').val($(this).find("span").text());
+		
+		var colorpicker = winElement.find('.lebals-colorpicker');
+		colorpicker.find('input[name="backgroundColor"]').val(rgb2hex($(this).css("backgroundColor")))
+		.css("background-color", $(this).css("backgroundColor")).focus().end()
+		.find('input[name="fontColor"]').val(rgb2hex($(this).css("color"))).css("background-color", $(this).css("color")).focus().end()
+		.find('input[name="borderColor"]').val(rgb2hex($(this).css("border-left-color"))).css("background-color", $(this).css("border-left-color")).focus().end()
+		.find('.preview-label-outer').css({
+			'background-color':$(this).css("backgroundColor"),
+			'color':$(this).css("color"),
+			'border-color':$(this).css("border-left-color")
+		})		
+		winElement.find(".preview-label-inner").text($(this).text());
+	}
+	//TODO Mudar quando API abstrair atualizações no cache
+	DataLayer.remove('label',false);
+	labels = DataLayer.get('label',{criteria:{order: 'name'}});
+	
+	if(labels){
+		Label_List = winElement
+		.find(".label-list-container").html(DataLayer.render("../prototype/modules/mail/templates/label_list.ejs", {labels: labels}));
+		
+	}else{
+		/**
+		* Quando não existir marcadores cadastrados
+		* exibe a mensagem informando o usuário de que não há
+		* nenhum marcador cadastrado.
+		*/
+		Label_List = winElement
+		.find(".label-list-container").html('<ul class="label-list"><li class="empty-item">Nenhum Marcador Cadastrado.</li></ul>');
+		
+	}
+	Label_List.end()
+	.find('.button').button()
+	.filter('.edit').button({icons:{primary:'ui-icon-pencil'}, text:false}).end()
+	.filter('.close').button({icons:{primary:'ui-icon-close'}, text:false}); 	
+	
+	var editLabel = function(){	
+		var conteudoSpan = $(this).parent().find(".text-list").text();
+		var span = $(this).parent().find(".text-list");
+		$(this).parent().trigger('click').unbind('click', configureLabel).find("span.text-list")
+		.html('<input name="edit-value-list" class="edit-value-list" type="text" value="'+conteudoSpan+'">').find("input[name='edit-value-list']").keydown(function(event){
+			event.stopPropagation();
+			$("input.edit-value-list").keyup(function () {
+				var value = $(this).val();
+				winElement.find('.input-nome').val(value);
+			}).keyup();
+			if(event.keyCode == 13){
+				$(span).html($(".label-list").find(".edit-value-list").val())
+				.parent().find('.edit').removeClass("hidden").parents("li").click(configureLabel).trigger("click");
+				winElement.find(".buttons .save-label").trigger("click");
+			}else if( event.keyCode == 27){
+				$(this).trigger("focusout");
+			}
+		}).focusout(function(){
+			$(span).html(conteudoSpan)
+			.parent().find('.edit').removeClass("hidden").parents("li").click(configureLabel);
+		}).focus();
+		$(this).addClass("hidden");
+	}
+	
+	winElement.find('.edit').click(editLabel);
+	winElement.find('.close').click(function(event){
+		var id = $(this).parents(".label-item").attr("class").match(/label-item-([\d]+[()a-zA-Z]*)/)[1];
+		confirmDelete(id);
+		event.stopImmediatePropagation();
+	});
+	/**
+	* Testa novamente se existem marcadores cadastrados, 
+	* pois nesse momento os botões Excluir, Desfazer e Salvar já existem
+	* e os marcadores já estão listados na tela,
+	* então é possível alterar o text do Salvar para Criar,
+	* caso não exista nenhum marcador cadastrado e listado na tela de configuração dos marcadores,
+	* ou "marcar" o primeiro marcador listado com o "triangulo", caracterizando que o mesmo está selecionado.
+	*/
+	
+	//marca 'd agua e adicionar label na lista.
+	winElement.find(".insert-label").Watermark(winElement.find(".insert-label").val());
+	
+	$("input.insert-label").keyup(function () {
+		$.Watermark.HideAll();
+		var value = $(this).val();
+		winElement.find('.input-nome').val(value);
+	}).keyup();
+	
+	if (!(labels)){
+		winElement.find(".buttons .save-label .ui-button-text").text('Criar');
+		$(".delete-label").button("disable");
+	}else{
+		winElement.find(".label-list li:first").addClass("selected").prepend("<img src='../prototype/modules/mail/img/triangle.png' style='margin: 0 5px 0 -5px;'>");
+	}
+	$(".save-label").button("disable");
+	/**
+	* seta a ação de click para os marcadores listados na tela
+	*/
+	winElement.find(".label-list li").not(".empty-item").click(configureLabel);
+	
+	if (data.selectedItem)
+		winElement.find(".label-list li.label-item-"+data.selectedItem).trigger("click");
+	else
+		winElement.find(".label-list li:first").trigger("click");
+		
+	var dataColorPicker = {
+		colorsSuggestions: colors_suggestions()
+	};
+	
+	winElement.find('select.color-suggestions').change(function() {
+		$(".save-label").button("enable");
+		var colorpicker = winElement.find('.lebals-colorpicker');
+		var colors;
+		if(colors = dataColorPicker.colorsSuggestions[$(this).val()]) {	
+			colorpicker
+			.find('input[name="fontColor"]').val(colors.font).focus().end()	
+			.find('input[name="backgroundColor"]').val(colors.background).focus().end()
+			.find('input[name="borderColor"]').val(colors.border).focus().end()
+
+			.find('.preview-label-outer').css({
+				'background-color':dataColorPicker.colorsSuggestions[$(this).val()].background,
+				'border-color':dataColorPicker.colorsSuggestions[$(this).val()].border,
+				'color':dataColorPicker.colorsSuggestions[$(this).val()].font 
+			});
+		}					
+	});
+	var colorpickerPreviewChange = function(color) {
+			
+		var pickedup = winElement.find('.colorwell-selected').val(color).css('background-color', color);
+
+		$(".save-label").button("enable");
+		
+		var colorpicker = winElement.find('.lebals-colorpicker');			
+
+		if (pickedup.is('input[name="backgroundColor"]')) {
+			colorpicker.find('.preview-label-outer').css('background-color',color);
+		} else if (pickedup.is('input[name="fontColor"]')) {
+			colorpicker.find('.preview-label-outer').css('color',color);
+		} else if (pickedup.is('input[name="borderColor"]')) {
+			colorpicker.find('.preview-label-outer').css('border-color',color);
+		}		
+	} 
+		
+	var f = $.farbtastic(winElement.find('.colorpicker'), colorpickerPreviewChange);
+	var selected;
+				
+	winElement.find('.colorwell').each(function () {
+		f.linkTo(this);
+	})
+	.focus(function() {
+		if (selected) {
+			$(selected).removeClass('colorwell-selected');
+		}
+		$(selected = this).addClass('colorwell-selected');
+		f.linkTo(this, colorpickerPreviewChange);
+		f.linkTo(colorpickerPreviewChange);
+	});
+	
+
+	
+	winElement.find(".add-label-button").click(function (event) {
+		$.Watermark.HideAll();
+		var name = winElement.find(".insert-label").val();
+		if(name.length >= 2){
+			DataLayer.put('label', {name: name, uid: User.me.id});
+			
+			$(".add-label-button").removeClass("ui-icon ui-icon-plus")
+			.html('<img alt="Carregando" title="Carregando" style="margin-left:10px;" src="../prototype/modules/mail/img/loader.gif" />');
+			
+			DataLayer.commit(false, false, function(){
+
+				labels = DataLayer.get('label',{criteria:{order: 'id'}}, true);
+				newLabel = {
+					id: labels[labels.length -1 ].id, 
+					name : labels[labels.length -1].name,
+					uid: User.me.id
+				};
+
+				$(".label-list-container ul").find(".empty-item").css("display","none");
+				
+				$(".label-list-container ul, .list-label ul")
+				.prepend(DataLayer.render("../prototype/modules/mail/templates/label_listitem.ejs", newLabel))
+				.find("li:first")
+				.fadeIn("slow").click(configureLabel);
+				
+				$(".label-list-container .label-list li").not(".empty-item").click(function(){
+					$(".save-label").button("disable");
+					$(".label-list-container .label-list li").find("img").remove();
+					$(".label-list-container .label-list li.label-item").removeClass("selected");
+					$(this).prepend("<img src='../prototype/modules/mail/img/triangle.png' style='margin: 0 5px 0 -5px;'>");
+					$(this).addClass("selected");
+				});
+				
+				$(".label-list-container .label-list li").find('.button').button()
+				.filter('.edit').button({icons:{primary:'ui-icon-pencil'}, text:false}).end()
+				.filter('.close').button({icons:{primary:'ui-icon-close'}, text:false});
+					
+				winElement.find('.edit').unbind("click").click(editLabel);
+				
+				winElement.find('.close').click(function(event){
+					var id = $(this).parents(".label-item").attr("class").match(/label-item-([\d]+[()a-zA-Z]*)/)[1];
+					confirmDelete(id);
+					event.stopImmediatePropagation();
+				});
+				
+				$.Watermark.ShowAll();
+				winElement.find(".insert-label").val("");
+				
+				//posiciona para edição o label inserido			
+				winElement.find("ul.label-list li:first").trigger("click");			
+				winElement.find(".buttons .save-label .ui-button-text").text('Salvar');
+				$(".delete-label").button("enable");		
+
+				//Remove o título da lista de Marcadores da tela principal do módulo
+				$(".my-labels").removeClass("hidden");
+				/**
+				* atualiza menu
+				* Remove o menu presente em cada mensagem listada em uma pasta 
+				* e carrega novamente para que os dados sejam atualizados
+				*/
+				$.contextMenu( 'destroy', ".table_box tbody tr");
+				loadMenu();
+				$(".add-label-button").empty()
+				.addClass("ui-icon ui-icon-plus");
+			});
+			} else {
+				alert("Mínimo 2 caracteres");
+			}
+
+		event.stopImmediatePropagation();
+	});
+	
+	winElement.find('.insert-label').keydown(function(event, ui) {
+		if (event.keyCode == 13)
+			winElement.find(".add-label-button").trigger('click');
+	});
+
+	function confirmDelete(id){
+
+		$.Zebra_Dialog('<strong>Deseja excluir esse marcador?</strong>', {
+			'type':     'question',
+			'title':    'Atenção',
+			'buttons': ['Sim','Não'],	
+			'onClose':  function(caption) {
+				if(caption == 'Sim'){
+					deleteLabel(id);
+				}
+			}
+		});	
+	}	
+		
+	function deleteLabel(id){
+		$(".label-list li").each(function () {
+			var regex_match = $(this).attr("class").match(/label-item-([\d]+[()a-zA-Z]*)/);
+			if (regex_match && regex_match[1] && regex_match[1] == id) {	
+				$(this).remove();
+			}
+		});
+		DataLayer.remove('label', id);
+		DataLayer.commit();
+		winElement.find(".label-list li:first").trigger("click");
+		
+		if($(".label-list li").length == 0){
+			winElement.find(".label-list-container").html('<ul class="label-list"><li class="empty-item">Nenhum Marcador Cadastrado.</li></ul>');			
+		} 
+		var qtdLi = $(".label-list-container ul").find("li").not(".empty-item").length;
+		if (qtdLi == 0){
+			$(".my-labels").addClass("hidden");
+			$(".label-list-container ul").find(".empty-item").css("display","");
+			winElement.find(".buttons .save-label .ui-button-text").text('Criar');
+			$(".delete-label").button("disable");	
+					
+			winElement.find('.input-nome').val("");
+			winElement.find(".preview-label-inner").text("");
+		
+			var colorpicker = winElement.find('.lebals-colorpicker');
+			colorpicker.find('input[name="backgroundColor"]').val("#ffffff")
+			.css("background-color", "#ffffff").focus().end()
+			.find('input[name="fontColor"]').val("#444444").css("background-color", "#000000").focus().end()
+			.find('input[name="borderColor"]').val("#cccccc").css("background-color", "#000000").focus().end()
+			.find('.preview-label-outer').css({
+				'background-color':"#ffffff",
+				'color':"#444444",
+				'border-color':"#cccccc"
+			});
+			$(".input-nome").keyup(function () {
+				var value = $(this).val();
+				winElement.find('.preview-label-inner').text(value);
+			}).keyup();				
+		}		
+	}
+	//excluir marcador {deve ser para o botão grande na janela de edição e nao o pequeno da lista}
+	winElement.find(".buttons .delete-label").click(function(event){
+		var id = winElement.find(".edit-label").val();
+		confirmDelete(id);
+		event.stopImmediatePropagation();
+	});
+	$(".label-list-container .label-list li").not(".empty-item").click(function(){
+		$(".label-list-container .label-list li").find("img").remove();
+		$(".label-list-container .label-list li.label-item").removeClass("selected");
+		$(this).prepend("<img src='../prototype/modules/mail/img/triangle.png' style='margin: 0 5px 0 -5px;'>");
+		$(this).addClass("selected");
+	});
+		
+	//salvar/criar marcador
+	winElement.find(".buttons .save-label").click(function(){
+		$(".save-label").button("disable");
+		var labelEdited = {
+			id : winElement.find(".edit-label").val(),
+			uid: User.me.id,
+			name : winElement.find('.input-nome').val(),
+			backgroundColor : winElement.find("input[name='backgroundColor']").val(),
+			fontColor : winElement.find("input[name='fontColor']").val(),
+			borderColor : winElement.find("input[name='borderColor']").val()
+		}
+		var qtdLi = $(".label-list-container ul").find("li").not(".empty-item").length;	
+		// salvar marcador
+		if(qtdLi > 0){
+			$(".label-list-container .label-list li").each(function(){
+				var regex_match_2 = $(this).attr("class").match(/label-item-([\d]+[()a-zA-Z]*)/);
+				
+				 if(regex_match_2 && regex_match_2[1] && regex_match_2[1] == labelEdited.id){
+				   $(this).html("<input type='hidden' name='labelItemId' class='id-item-list' value='"+labelEdited.id+"'>"+"<span class='text-list'>"+labelEdited.name+"</span><div class='button close tiny' style='float: right'></div><div class='button edit tiny' style='float: right'></div>").css({
+					"background" : labelEdited.backgroundColor,
+					"color" : labelEdited.fontColor, 
+					"border-color" : labelEdited.borderColor	
+				   });
+				 }	
+			});
+			
+			$("#MyMarckersList .label-list li").each(function(){
+				var regex_match_2 = $(this).attr("class").match(/label-item-([\d]+[()a-zA-Z]*)/);
+				
+				if(regex_match_2 && regex_match_2[1] && regex_match_2[1] == labelEdited.id){
+					$(this).html("<input type='hidden' name='labelItemId' class='id-item-list' value='"+labelEdited.id+"'>"+"<span>"+labelEdited.name+"</span>");
+					$(this).find(".square-color").css('background', labelEdited.backgroundColor);
+				}	
+			});
+			DataLayer.put('label', labelEdited.id, labelEdited);
+			DataLayer.commit(false, false, function(){
+				$("#MyMarckersList")
+				.html(
+					"<div class='my-labels'>" +
+						"<img src='../prototype/modules/mail/img/tag.png'/>" +
+						"<a class='title-my-labels' tabindex='0' role='button' aria-expanded='false' title='Meus marcadores'>Meus marcadores</a>" +
+						
+						"<span class='status-list-labels ui-icon ui-icon-triangle-1-s'></span>" +
+					"</div>"
+				)
+				.append(DataLayer.render("../prototype/modules/mail/templates/label_list.ejs", {labels:DataLayer.get('label', true)} ))
+				.find("li.label-item").css({"background-color":"#ffffff", "border-color":"#CCCCCC", "color":"#444444"})
+				.find(".square-color").css("display","").click(function(){
+					$(this).parent(".label-item").each(function(){
+						configureLabels({selectedItem: $(this).attr('class').match(/label-item-([\d]+[()a-zA-Z]*)/)[1]});
+					});
+				});
+				
+				$("#MyMarckersList a.title-my-labels").click(function() {
+					$("#MyMarckersList ul.label-list").toggleClass("hidden")
+					$('#MyMarckersList .status-list-labels').toggleClass("ui-icon-triangle-1-s");
+					$('#MyMarckersList .status-list-labels').toggleClass("ui-icon-triangle-1-n");
+				 });
+	 
+				$.Watermark.ShowAll();
+				winElement.find(".insert-label").val("");
+				$(".label-list-container .label-list li").find('.button').button()
+					.filter('.edit').button({icons:{primary:'ui-icon-pencil'}, text:false}).end()
+					.filter('.close').button({icons:{primary:'ui-icon-close'}, text:false});
+				winElement.find('.edit').unbind("click").click(editLabel);
+				
+				winElement.find('.close').click(function(event){
+					var id = $(this).parents(".label-item").attr("class").match(/label-item-([\d]+[()a-zA-Z]*)/)[1];
+					confirmDelete(id);
+					event.stopImmediatePropagation();
+				});
+			});
+		// criar marcador
+		} else{
+			var nameLabel = winElement.find(".input-nome").val();
+			var labelCreated = {
+				uid: User.me.id,
+				name : nameLabel,
+				backgroundColor : winElement.find("input[name='backgroundColor']").val(),
+				fontColor : winElement.find("input[name='fontColor']").val(),
+				borderColor : winElement.find("input[name='borderColor']").val()
+			}
+			
+			if(nameLabel.length >= 2){
+				DataLayer.put('label', labelCreated);
+				DataLayer.commit(false, false, function(){
+
+					labels = DataLayer.get('label',{criteria:{order: 'id'}}, true);
+					newLabel = {
+						id: labels[labels.length - 1].id, 
+						name : labels[labels.length- 1].name,
+						uid: User.me.id,
+						bgColor : winElement.find("input[name='backgroundColor']").val(),
+						fontColor : winElement.find("input[name='fontColor']").val(),
+						borderColor : winElement.find("input[name='borderColor']").val()
+					};
+
+					$(".label-list-container ul").find(".empty-item").css("display","none");
+					$(".label-list-container ul")
+					.prepend(DataLayer.render("../prototype/modules/mail/templates/label_listitem.ejs", newLabel))
+					.find("li:first")
+					.fadeIn("slow").click(configureLabel);
+					
+					$("#MyMarckersList")
+					.html(
+						"<div class='my-labels'>" +
+							"<img src='../prototype/modules/mail/img/tag.png'/>" +
+							"<a class='title-my-labels' tabindex='0' role='button' aria-expanded='false' title='Meus marcadores'>Meus marcadores</a>" +
+							
+							"<span class='status-list-labels ui-icon ui-icon-triangle-1-s'></span>" +
+						"</div>"
+					)
+					
+					.append(DataLayer.render("../prototype/modules/mail/templates/label_list.ejs", {labels:DataLayer.get('label', true)} ))
+					.find("li.label-item").css({"background-color":"#ffffff", "border-color":"#CCCCCC", "color":"#444444"})
+					.find(".square-color").css("display","").click(function(){
+						$(this).parent(".label-item").each(function(){
+							configureLabels({selectedItem: $(this).attr('class').match(/label-item-([\d]+[()a-zA-Z]*)/)[1]});
+						});
+					});
+					$("#MyMarckersList a.title-my-labels").click(function() {
+						$("#MyMarckersList ul.label-list").toggleClass("hidden")
+						$('#MyMarckersList .status-list-labels').toggleClass("ui-icon-triangle-1-s");
+						$('#MyMarckersList .status-list-labels').toggleClass("ui-icon-triangle-1-n");
+					 });
+	 
+					$(".label-list-container .label-list li").not(".empty-item").click(function(){
+						$(".label-list-container .label-list li").find("img").remove();
+						$(".label-list-container .label-list li.label-item").removeClass("selected");
+						$(this).prepend("<img src='../prototype/modules/mail/img/triangle.png' style='margin: 0 5px 0 -5px;'>");
+						$(this).addClass("selected");
+					});
+					
+					$(".label-list-container .label-list li").find('.button').button()
+					.filter('.edit').button({icons:{primary:'ui-icon-pencil'}, text:false}).end()
+					.filter('.close').button({icons:{primary:'ui-icon-close'}, text:false});
+					$.Watermark.ShowAll();
+					winElement.find(".insert-label").val("");
+					
+					//posiciona para edição o label inserido			
+					winElement.find("ul.label-list li:first").trigger("click");			
+					winElement.find(".buttons .save-label .ui-button-text").text('Salvar');
+					$(".delete-label").button("enable");
+					
+					winElement.find('.edit').unbind("click").click(editLabel);
+				
+					winElement.find('.close').click(function(event){
+						var id = $(this).parents(".label-item").attr("class").match(/label-item-([\d]+[()a-zA-Z]*)/)[1];
+						confirmDelete(id);
+						event.stopImmediatePropagation();
+					});
+					
+					$(".my-labels").removeClass("hidden");
+				});
+			} else {
+				alert("Mínimo 2 caracteres");
+			}		
+		}		
+		/**
+		* atualiza menu
+		* Remove o menu presente em cada mensagem listada em uma pasta 
+		* e carrega novamente para que os dados sejam atualizados
+		*/
+		$.contextMenu( 'destroy', ".table_box tbody tr");
+		loadMenu();
+		
+		$(".label-list-container .label-list").find(".label-item-"+labelEdited.id).trigger("click");
+	});	
+	//desfazer marcador
+	winElement.find(".buttons .undo-label").click(function(event){
+		var edit = winElement.find(".edit-label").val();		
+		$(".label-list-container .label-list li").each(function(){
+			var regex_match_3 = $(this).attr("class").match(/label-item-([\d]+[()a-zA-Z]*)/);
+			if(regex_match_3 && regex_match_3[1] && regex_match_3[1] == edit){
+				$(this).trigger("click");
+			}
+		});
+	});
+	
+	//fechar
+	$(".button-close-window .close-window").click(function(){
+		$(".label-configure-win").dialog("close");
+	});	
+			
+	$(".configure-label-content").find("input[type='text']").focus(function () {
+		$(this).keyup(function(){
+			var value = $(this).val();
+			if(value){
+				$(".save-label").button("enable");	
+			}else{
+				$(".save-label").button("disable");	
+			}
+		});
+
+	});	
+	
+	$(".input-nome").keyup(function () {
+				var value = $(this).val();
+				winElement.find('.preview-label-inner').text(value);
+	}).keyup();
+	
+}
+
+/**
+ * TODO:
+ * * Qunado excluir um marcador deve ser removido das mensagens sem que seja necessario atualizar o Expresso.
+ * * Fazer abrir a configuração do Marcador pela lista do modulo principal apenas quando criado um marcador sem clicar no botão "salvar".
+ */
